drama.shaders = {};
drama.shaders["lighten"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcStart;\nuniform mediump vec2 srcEnd;\nuniform lowp sampler2D samplerBack;\nuniform mediump vec2 destStart;\nuniform mediump vec2 destEnd;\n\nvoid main(void)\n{	lowp vec4 front = texture2D(samplerFront, vTex);\n	front.rgb /= front.a;\n	\n	mediump vec2 tex = (vTex - srcStart) / (srcEnd - srcStart);\n	lowp vec4 back = texture2D(samplerBack, mix(destStart, destEnd, tex));\n	back.rgb /= back.a;	front.rgb = max(front.rgb, back.rgb) * front.a;\n	\n	gl_FragColor = front * back.a;\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: []
};

drama.shaders["screen"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcStart;\nuniform mediump vec2 srcEnd;\nuniform lowp sampler2D samplerBack;\nuniform mediump vec2 destStart;\nuniform mediump vec2 destEnd;\n\nvoid main(void)\n{	lowp vec4 front = texture2D(samplerFront, vTex);\n	\n	mediump vec2 tex = (vTex - srcStart) / (srcEnd - srcStart);\n	lowp vec4 back = texture2D(samplerBack, mix(destStart, destEnd, tex));	front.rgb = 1.0 - ((1.0 - front.rgb) * (1.0 - back.rgb * front.a));\n	\n	gl_FragColor = front;\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: []
};

drama.shaders["warpripple"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcOriginStart;\nuniform mediump vec2 srcOriginEnd;\nuniform mediump float seconds;\nuniform mediump vec2 pixelSize;\n\nuniform mediump float freq;\nuniform mediump float amp;\nuniform mediump float speed;\n\nconst mediump float PI = 3.1415926;\n\nvoid main(void)\n{\n	mediump vec2 srcOriginSize = srcOriginEnd - srcOriginStart;\n	mediump vec2 tex = (vTex - srcOriginStart) / srcOriginSize;\n	tex = tex * 2.0 - 1.0;\n		\n	mediump float d = length(tex);\n	mediump float a = atan(tex.y, tex.x);\n	\n	d += sin((d * 2.0 * PI) * freq / (pixelSize.x * 750.0) + (seconds * speed)) * amp * (pixelSize.x * 750.0);\n	\n	tex.x = cos(a) * d;\n	tex.y = sin(a) * d;\n	\n	tex = (tex + 1.0) / 2.0;\n	tex = clamp(tex, 0.0, 1.0);\n	tex = tex * srcOriginSize + srcOriginStart;\n	\n	gl_FragColor = texture2D(samplerFront, tex);\n}\n",
	extendBoxHorizontal: 50,
	extendBoxVertical: 50,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: true,
	parameters: [["freq",0,0],["amp",0,1],["speed",0,0]]
};
